// Generated by CoffeeScript 1.9.0
var AuthenticationMethods, BackendMessage, messageClass, name, typeOIDs,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  __hasProp = {}.hasOwnProperty;

AuthenticationMethods = require('./authentication').methods;

typeOIDs = require('./types').typeOIDs;

BackendMessage = (function() {
  BackendMessage.prototype.typeId = null;

  function BackendMessage(buffer) {
    this.read(buffer);
  }

  BackendMessage.prototype.read = function(buffer) {};

  return BackendMessage;

})();

BackendMessage.Authentication = (function(_super) {
  __extends(Authentication, _super);

  function Authentication() {
    return Authentication.__super__.constructor.apply(this, arguments);
  }

  Authentication.prototype.typeId = 82;

  Authentication.prototype.read = function(buffer) {
    this.method = buffer.readUInt32BE(0);
    if (this.method === AuthenticationMethods.MD5_PASSWORD) {
      return this.salt = buffer.readUInt32BE(4);
    } else if (this.method === AuthenticationMethods.CRYPT_PASSWORD) {
      return this.salt = buffer.readUInt16BE(4);
    }
  };

  return Authentication;

})(BackendMessage);

BackendMessage.BackendKeyData = (function(_super) {
  __extends(BackendKeyData, _super);

  function BackendKeyData() {
    return BackendKeyData.__super__.constructor.apply(this, arguments);
  }

  BackendKeyData.prototype.typeId = 75;

  BackendKeyData.prototype.read = function(buffer) {
    this.pid = buffer.readUInt32BE(0);
    return this.key = buffer.readUInt32BE(4);
  };

  return BackendKeyData;

})(BackendMessage);

BackendMessage.ParameterStatus = (function(_super) {
  __extends(ParameterStatus, _super);

  function ParameterStatus() {
    return ParameterStatus.__super__.constructor.apply(this, arguments);
  }

  ParameterStatus.prototype.typeId = 83;

  ParameterStatus.prototype.read = function(buffer) {
    this.name = buffer.readZeroTerminatedString(0);
    return this.value = buffer.readZeroTerminatedString(this.name.length + 1);
  };

  return ParameterStatus;

})(BackendMessage);

BackendMessage.NotificationResponse = (function(_super) {
  __extends(NotificationResponse, _super);

  function NotificationResponse() {
    return NotificationResponse.__super__.constructor.apply(this, arguments);
  }

  NotificationResponse.prototype.typeId = 65;

  NotificationResponse.prototype.read = function(buffer) {
    this.pid = buffer.readUInt32BE(4);
    this.channel = buffer.readZeroTerminatedString(4);
    return this.payload = buffer.readZeroTerminatedString(this.channel.length + 5);
  };

  return NotificationResponse;

})(BackendMessage);

BackendMessage.EmptyQueryResponse = (function(_super) {
  __extends(EmptyQueryResponse, _super);

  function EmptyQueryResponse() {
    return EmptyQueryResponse.__super__.constructor.apply(this, arguments);
  }

  EmptyQueryResponse.prototype.typeId = 73;

  return EmptyQueryResponse;

})(BackendMessage);

BackendMessage.RowDescription = (function(_super) {
  __extends(RowDescription, _super);

  function RowDescription() {
    return RowDescription.__super__.constructor.apply(this, arguments);
  }

  RowDescription.prototype.typeId = 84;

  RowDescription.prototype.read = function(buffer) {
    var fieldDescriptor, formatCode, i, modifier, name, numberOfFields, pos, size, tableFieldIndex, tableOID, typeOID, _i;
    numberOfFields = buffer.readUInt16BE(0);
    pos = 2;
    this.columns = [];
    for (i = _i = 0; 0 <= numberOfFields ? _i < numberOfFields : _i > numberOfFields; i = 0 <= numberOfFields ? ++_i : --_i) {
      name = buffer.readZeroTerminatedString(pos);
      pos += Buffer.byteLength(name) + 1;
      tableOID = buffer.readUInt32BE(pos);
      pos += 4;
      tableFieldIndex = buffer.readUInt16BE(pos);
      pos += 2;
      typeOID = buffer.readUInt32BE(pos);
      pos += 4;
      size = buffer.readUInt16BE(pos);
      pos += 2;
      modifier = buffer.readUInt32BE(pos);
      pos += 4;
      formatCode = buffer.readUInt16BE(pos);
      pos += 2;
      fieldDescriptor = {
        name: name,
        tableOID: tableOID,
        tableFieldIndex: tableFieldIndex,
        typeOID: typeOID,
        type: typeOIDs[typeOID],
        size: size,
        modifier: modifier,
        formatCode: formatCode
      };
      this.columns.push(fieldDescriptor);
    }
    return void 0;
  };

  return RowDescription;

})(BackendMessage);

BackendMessage.DataRow = (function(_super) {
  __extends(DataRow, _super);

  function DataRow() {
    return DataRow.__super__.constructor.apply(this, arguments);
  }

  DataRow.prototype.typeId = 68;

  DataRow.prototype.read = function(buffer) {
    var data, i, length, numberOfFields, pos, _i;
    numberOfFields = buffer.readUInt16BE(0);
    pos = 2;
    this.values = [];
    for (i = _i = 0; 0 <= numberOfFields ? _i < numberOfFields : _i > numberOfFields; i = 0 <= numberOfFields ? ++_i : --_i) {
      length = buffer.readUInt32BE(pos);
      pos += 4;
      if (length === 4294967295) {
        data = null;
      } else {
        data = buffer.slice(pos, pos + length);
        pos += length;
      }
      this.values.push(data);
    }
    return void 0;
  };

  return DataRow;

})(BackendMessage);

BackendMessage.CommandComplete = (function(_super) {
  __extends(CommandComplete, _super);

  function CommandComplete() {
    return CommandComplete.__super__.constructor.apply(this, arguments);
  }

  CommandComplete.prototype.typeId = 67;

  CommandComplete.prototype.read = function(buffer) {
    return this.status = buffer.readZeroTerminatedString(0);
  };

  return CommandComplete;

})(BackendMessage);

BackendMessage.CloseComplete = (function(_super) {
  __extends(CloseComplete, _super);

  function CloseComplete() {
    return CloseComplete.__super__.constructor.apply(this, arguments);
  }

  CloseComplete.prototype.typeId = 51;

  return CloseComplete;

})(BackendMessage);

BackendMessage.ParameterDescription = (function(_super) {
  __extends(ParameterDescription, _super);

  function ParameterDescription() {
    return ParameterDescription.__super__.constructor.apply(this, arguments);
  }

  ParameterDescription.prototype.typeId = 116;

  ParameterDescription.prototype.read = function(buffer) {
    var count, i;
    count = buffer.readUInt16BE(0);
    return this.parameterTypes = (function() {
      var _i, _results;
      _results = [];
      for (i = _i = 0; 0 <= count ? _i < count : _i > count; i = 0 <= count ? ++_i : --_i) {
        _results.push(buffer.readUInt32BE(2 + i * 4));
      }
      return _results;
    })();
  };

  return ParameterDescription;

})(BackendMessage);

BackendMessage.ParseComplete = (function(_super) {
  __extends(ParseComplete, _super);

  function ParseComplete() {
    return ParseComplete.__super__.constructor.apply(this, arguments);
  }

  ParseComplete.prototype.typeId = 49;

  return ParseComplete;

})(BackendMessage);

BackendMessage.ErrorResponse = (function(_super) {
  __extends(ErrorResponse, _super);

  function ErrorResponse() {
    return ErrorResponse.__super__.constructor.apply(this, arguments);
  }

  ErrorResponse.prototype.typeId = 69;

  ErrorResponse.prototype.fieldNames = {
    83: 'Severity',
    67: 'Code',
    77: 'Message',
    68: 'Detail',
    72: 'Hint',
    80: 'Position',
    112: 'Internal position',
    113: 'Internal query',
    87: 'Where',
    70: 'File',
    76: 'Line',
    82: 'Routine'
  };

  ErrorResponse.prototype.read = function(buffer) {
    var fieldCode, pos, value;
    this.information = {};
    fieldCode = buffer.readUInt8(0);
    pos = 1;
    while (fieldCode !== 0x00) {
      value = buffer.readZeroTerminatedString(pos);
      this.information[this.fieldNames[fieldCode] || fieldCode] = value;
      pos += Buffer.byteLength(value) + 1;
      fieldCode = buffer.readUInt8(pos);
      pos += 1;
    }
    return this.message = this.information['Message'];
  };

  return ErrorResponse;

})(BackendMessage);

BackendMessage.NoticeResponse = (function(_super) {
  __extends(NoticeResponse, _super);

  function NoticeResponse() {
    return NoticeResponse.__super__.constructor.apply(this, arguments);
  }

  NoticeResponse.prototype.typeId = 78;

  return NoticeResponse;

})(BackendMessage.ErrorResponse);

BackendMessage.ReadyForQuery = (function(_super) {
  __extends(ReadyForQuery, _super);

  function ReadyForQuery() {
    return ReadyForQuery.__super__.constructor.apply(this, arguments);
  }

  ReadyForQuery.prototype.typeId = 90;

  ReadyForQuery.prototype.read = function(buffer) {
    return this.transactionStatus = buffer.readUInt8(0);
  };

  return ReadyForQuery;

})(BackendMessage);

BackendMessage.CopyFileResponse = (function(_super) {
  __extends(CopyFileResponse, _super);

  function CopyFileResponse() {
    return CopyFileResponse.__super__.constructor.apply(this, arguments);
  }

  CopyFileResponse.prototype.typeId = 70;

  CopyFileResponse.prototype.read = function(buffer) {
    var filename, i, last, numberOfFiles, pos, _i;
    this.files = [];
    numberOfFiles = buffer.readUInt16BE(0);
    pos = 2;
    for (i = _i = 0; 0 <= numberOfFiles ? _i < numberOfFiles : _i > numberOfFiles; i = 0 <= numberOfFiles ? ++_i : --_i) {
      filename = buffer.readZeroTerminatedString(pos);
      this.files.push(filename);
      pos += filename.length + 1;
    }
    return last = buffer.readUInt16BE(pos);
  };

  return CopyFileResponse;

})(BackendMessage);

BackendMessage.CopyInResponse = (function(_super) {
  __extends(CopyInResponse, _super);

  function CopyInResponse() {
    return CopyInResponse.__super__.constructor.apply(this, arguments);
  }

  CopyInResponse.prototype.typeId = 71;

  CopyInResponse.prototype.read = function(buffer) {
    var i, numberOfFields, pos, _i;
    this.globalFormatType = buffer.readUInt8(0);
    this.fieldFormatTypes = [];
    numberOfFields = buffer.readUInt16BE(1);
    pos = 3;
    for (i = _i = 0; 0 <= numberOfFields ? _i < numberOfFields : _i > numberOfFields; i = 0 <= numberOfFields ? ++_i : --_i) {
      this.fieldFormatTypes.push(buffer.readUInt8(pos));
      pos += 1;
    }
    return void 0;
  };

  return CopyInResponse;

})(BackendMessage);

BackendMessage.types = {};

for (name in BackendMessage) {
  messageClass = BackendMessage[name];
  if (messageClass.prototype && (messageClass.prototype.typeId != null)) {
    messageClass.prototype.event = name;
    BackendMessage.types[messageClass.prototype.typeId] = messageClass;
  }
}

BackendMessage.fromBuffer = function(buffer) {
  var message, typeId;
  typeId = buffer.readUInt8(0);
  messageClass = BackendMessage.types[typeId];
  if (messageClass != null) {
    message = new messageClass(buffer.slice(5));
    return message;
  } else {
    throw new Error("Unknown message type: " + typeId);
  }
};

module.exports = BackendMessage;
